#include <bits/stdc++.h>

#define ll long long
#define ios ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);
#define mod 998244353

using namespace std;

ll n,m,b[100100],a[200100],c;

int main(){
    ios;
    cin>>n>>m;
    for (ll i=1;i<=n;i++)a[i]=i;
    for(ll i=1;i<=m;i++)cin>>b[i];
    cin>>c;

    for (ll i=0;i<=n-m;i++){
        for (ll j=1;j<=m;j++){
            a[i+b[j]]=a[i+j];
        }
    }
    ll ans=0,r=1;
    for (ll i=1;i<=n;i++){
        r*=c;
        ans+=((r*a[i])%mod);
        ans%=mod;
    }
    cout<<ans;
    return 0;
}